## lomiri-thumbnailer 3.0.0

=== CMakeLists.txt ===
# Default install location. Must be set here, before setting the project.
if (NOT DEFINED CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
    set(LOCAL_INSTALL "ON")
endif()

cmake_minimum_required(VERSION 3.0.2)
project(lomiri-thumbnailer VERSION "3.0.0" LANGUAGES C CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)


# Suppress complaints by cmake about COMPILE_DEFINITIONS_<Config> caused by qt5 cmake macros.
cmake_policy(SET CMP0043 OLD)

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lower case

set(ACCEPTED_BUILD_TYPES "" none release debug relwithdebinfo coverage)
list(FIND ACCEPTED_BUILD_TYPES "${cmake_build_type_lower}" IS_BUILD_TYPE_ACCEPTED)
if (${IS_BUILD_TYPE_ACCEPTED} EQUAL -1)
    message(FATAL_ERROR "Invalid CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}\nValid types are: ${ACCEPTED_BUILD_TYPES}")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++11 -Wall -pedantic -Wextra -fvisibility=hidden")

# Some additional warnings not included by the general flags set above.
set(EXTRA_C_WARNINGS "-Wcast-align -Wcast-qual -Wformat -Wredundant-decls -Wswitch-default")
set(EXTRA_CXX_WARNINGS "-Wnon-virtual-dtor -Wctor-dtor-privacy -Wold-style-cast")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_C_WARNINGS} ${EXTRA_CXX_WARNINGS}")

# By default, for release builds, warnings become hard errors.
if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
    option(Werror "Treat warnings as errors" ON)
else()
    option(Werror "Treat warnings as errors" OFF)
endif()

# If warnings are errors, don't error on deprecated declarations.
if (${Werror})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
    if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=deprecated-declarations")
    endif()
endif()

add_definitions(-DQT_NO_KEYWORDS)

include(GNUInstallDirs)

# liblomiri-thumbnailer-qt version
set(LIBTHUMBNAILER_QT lomiri-thumbnailer-qt)
set(LIBTHUMBNAILER_QT_SO_VERSION_MAJOR "1")
set(LIBTHUMBNAILER_QT_SO_VERSION_MINOR "0")
set(LIBTHUMBNAILER_QT_SO_VERSION_MICRO "0")
set(LIBTHUMBNAILER_QT_SO_VERSION ${LIBTHUMBNAILER_QT_SO_VERSION_MAJOR}.${LIBTHUMBNAILER_QT_SO_VERSION_MINOR})
set(LIBTHUMBNAILER_QT_HDR_INSTALL_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR}/${LIBTHUMBNAILER_QT}-${LIBTHUMBNAILER_QT_SO_VERSION})

# Encoding version of cache files
set(THUMBNAILER_CACHE_VERSION "2")

# Flags for thread/address sanitizer
set(SANITIZER "" CACHE STRING "Build with -fsanitize=<value> (legal values: thread, address)")

if ("${SANITIZER}" STREQUAL "")
    # Do nothing
elseif (${SANITIZER} STREQUAL "thread")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread -fno-omit-frame-pointer -g")
elseif (${SANITIZER} STREQUAL "address")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer -g")
else()
    message(FATAL_ERROR "Invalid SANITIZER setting: ${SANITIZER}")
endif()

# Some tests are slow, so make it possible not to run them
# during day-to-day development.
option(slowtests "Run slow tests" ON)
if (${slowtests})
    add_definitions(-DSLOW_TESTS=1)
else()
    add_definitions(-DSLOW_TESTS=0)
endif()

# TODO: Hack to allow disabling tests that need QDBus on xenial and yakkety,
#       due to broken Qt 5.6. Re-enable tests ASAP!
option(skip-dbus-tests "Skip DBus tests" ON)
if (${skip-dbus-tests})
    execute_process(COMMAND lsb_release -s -c OUTPUT_VARIABLE distro OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND uname -m OUTPUT_VARIABLE arch OUTPUT_STRIP_TRAILING_WHITESPACE)
    if (
            (${distro} STREQUAL "xenial" OR ${distro} STREQUAL "yakkety" OR ${distro} STREQUAL "zesty")
            AND
            (${arch} STREQUAL "aarch64" OR ${arch} STREQUAL "ppc" OR ${arch} STREQUAL "ppc64le")
       )
        message(WARNING "WARNING: Disabling DBus-related tests for ${distro}
         See https://bugs.launchpad.net/ubuntu/+source/thumbnailer/+bug/1613561
             https://bugs.launchpad.net/ubuntu/+source/qtbase-opensource-src/+bug/1625930")
        add_definitions(-DSKIP_DBUS_TESTS=1)
        add_definitions(-DDISTRO=\"${distro}\")
        add_definitions(-DARCH=\"${arch}\")
    endif()
endif()

option(ENABLE_UBUNTU_COMPAT "Enable Ubuntu.Thumbnailer QML compatibility type" OFF)

# Workaround static-TLS space exhaustion that happens due to some version of GlibC trying
# to optimize TLS access for dynamically-loaded (dlopen()'ed) libraries on some arch,
# but end up not having enough static-TLS area for the library that need it.
# For us, it happens with libgomp.so.1 loaded via libgstlibav.so plugin, inside vs-thumb.
# The workaround is to LD_PRELOAD libgomp.so.1, so that it has static TLS slots it needs.
#
# https://bugzilla.redhat.com/show_bug.cgi?id=1722181
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=964141
# https://sourceware.org/bugzilla/show_bug.cgi?id=25051
option(WORKAROUND_LIBGOMP_STATIC_TLS "Workaround libgomp.so.1 static TLS problem" OFF)
if (${WORKAROUND_LIBGOMP_STATIC_TLS})
    add_definitions(-DWORKAROUND_LIBGOMP_STATIC_TLS)
endif()

# Definitions for testing with valgrind.

configure_file(CTestCustom.cmake.in CTestCustom.cmake) # Tests in CTestCustom.cmake are skipped for valgrind

find_program(MEMORYCHECK_COMMAND NAMES valgrind)
if (MEMORYCHECK_COMMAND)
    set(MEMORYCHECK_COMMAND_OPTIONS
        "--suppressions=${CMAKE_SOURCE_DIR}/valgrind-suppress --errors-for-leak-kinds=definite --show-leak-kinds=definite --leak-check=full --num-callers=50 --error-exitcode=3"
    )
    add_custom_target(valgrind DEPENDS NightlyMemCheck)
else()
    message(WARNING "Cannot find valgrind: valgrind target will not be available")
endif()

include(CTest)
enable_testing()

#include(EnableCoverageReport)

include(cmake/UseGSettings.cmake)

set(SHARE_PRIV_DIR ${CMAKE_INSTALL_LIBDIR}/lomiri-thumbnailer)
set(SHARE_PRIV_ABS ${CMAKE_INSTALL_FULL_LIBDIR}/lomiri-thumbnailer)

find_package(Boost COMPONENTS filesystem iostreams regex system REQUIRED)
find_package(Threads REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5Quick REQUIRED)

include(FindPkgConfig)
pkg_check_modules(GST_DEPS REQUIRED gstreamer-1.0 gstreamer-plugins-base-1.0 gstreamer-tag-1.0)
pkg_check_modules(GOBJ_DEPS REQUIRED gobject-2.0)
pkg_check_modules(GIO_DEPS REQUIRED gio-2.0 gio-unix-2.0)
pkg_check_modules(IMG_DEPS REQUIRED gdk-pixbuf-2.0 libexif)
pkg_check_modules(LOMIRI_API_DEPS REQUIRED liblomiri-api)
pkg_check_modules(APPARMOR_DEPS REQUIRED libapparmor)
pkg_check_modules(TAGLIB_DEPS REQUIRED taglib)
pkg_check_modules(CACHE_DEPS REQUIRED libpersistent-cache-cpp)

include_directories(${GST_DEPS_INCLUDE_DIRS})
include_directories(${GOBJ_DEPS_INCLUDE_DIRS})
include_directories(${GIO_DEPS_INCLUDE_DIRS})
include_directories(${IMG_DEPS_INCLUDE_DIRS})
include_directories(${LOMIRI_API_DEPS_INCLUDE_DIRS})
include_directories(${APPARMOR_DEPS_INCLUDE_DIRS})
include_directories(${TAGLIB_DEPS_INCLUDE_DIRS})
include_directories(include)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)

add_subdirectory(src)
add_subdirectory(data)
add_subdirectory(plugins/Lomiri/Thumbnailer.0.1)
if (${ENABLE_UBUNTU_COMPAT})
    add_subdirectory(plugins/Ubuntu/Thumbnailer.0.1)
endif()
add_subdirectory(tests)
add_subdirectory(include)
add_subdirectory(man)
#add_subdirectory(doc)

#enable_coverage_report(
#    TARGETS
#        recovery_test         # Need to turn on coverage for this, to get the helper template instrumented.
#        testutils
#        test-seq
#        thumbnailer-admin
#        thumbnailer-qml
#        thumbnailer-qml-static
#        lomiri-thumbnailer-qt
#        thumbnailer-service
#        thumbnailer-static
#        vs-thumb
#        vs-thumb-static
#    FILTER
#        ${CMAKE_SOURCE_DIR}/tests/*
#        ${CMAKE_BINARY_DIR}/*
#    TESTS
#        ${UNIT_TEST_TARGETS}
#)

=== tests/dbus/CMakeLists.txt ===
add_executable(dbus_test dbus_test.cpp)
qt5_use_modules(dbus_test Network DBus Test)
target_link_libraries(dbus_test
    thumbnailer-static
    testutils
    Qt5::Network
    Qt5::DBus
    Qt5::Test
    gtest
)
add_test(dbus dbus_test)
add_dependencies(dbus_test thumbnailer-service)

=== tests/file_io/CMakeLists.txt ===
add_executable(file_io_test file_io_test.cpp)
qt5_use_modules(file_io_test Network)
target_link_libraries(file_io_test Qt5::Network thumbnailer-static gtest)
add_test(file_io file_io_test)

=== tests/headers/CMakeLists.txt ===
#
# Test that all header files compile stand-alone and that no public header includes an internal one.
#

set(root_inc_dir ${CMAKE_SOURCE_DIR}/include)

set(subdirs
    lomiri/thumbnailer/qt
)

find_package(Qt5Core REQUIRED)
set(extra_inc_dirs "${Qt5Core_INCLUDE_DIRS}")
find_package(Qt5Gui REQUIRED)
set(extra_inc_dirs "${extra_inc_dirs};${Qt5Gui_INCLUDE_DIRS}")
find_package(Qt5Network REQUIRED)
set(extra_inc_dirs "${extra_inc_dirs};${Qt5Network_INCLUDE_DIRS}")
pkg_check_modules(GLIB REQUIRED glib-2.0)
set(extra_inc_dirs "${extra_inc_dirs};${GLIB_INCLUDE_DIRS}")

# Replace ; with -I as the include directories are separated by ";"
string(REPLACE ";" " -I/" extra_inc_dirs "${extra_inc_dirs}")
set(extra_inc_dirs " -I${extra_inc_dirs}")

foreach(dir ${OTHER_INCLUDE_DIRS})
    set(other_inc_dirs "${other_inc_dirs} -I${dir}")
endforeach()

set(other_inc_dirs "${other_inc_dirs} -I${CMAKE_BINARY_DIR}/include -I${CMAKE_BINARY_DIR}")

foreach(dir ${subdirs})
    string(REPLACE "/" "-" location ${dir})

    set(public_inc_dir ${root_inc_dir}/${dir})
    set(internal_inc_dir ${public_inc_dir}/internal)

    # Test that each public header compiles stand-alone.
    add_test(stand-alone-${location}-headers
        ${CMAKE_CURRENT_SOURCE_DIR}/compile_headers.py
            ${public_inc_dir} ${CMAKE_CXX_COMPILER} "${CMAKE_CXX_COMPILER_ARG1} -fPIC -fsyntax-only -I${root_inc_dir} -I${public_inc_dir} ${other_inc_dirs} ${CMAKE_CXX_FLAGS} ${extra_inc_dirs}")

    # Test that each internal header compiles stand-alone.
    if (IS_DIRECTORY ${internal_inc_dir})
        add_test(stand-alone-${location}-internal-headers
            ${CMAKE_CURRENT_SOURCE_DIR}/compile_headers.py
                ${internal_inc_dir} ${CMAKE_CXX_COMPILER} "${CMAKE_CXX_COMPILER_ARG1} -fPIC -fsyntax-only -I${root_inc_dir} -I${internal_inc_dir} ${other_inc_dirs} ${CMAKE_CXX_FLAGS} ${extra_inc_dirs}")
    endif()

    # Test that no public header includes an internal header
    add_test(clean-public-${location}-headers ${CMAKE_CURRENT_SOURCE_DIR}/check_public_headers.py ${public_inc_dir})
endforeach()

=== tests/qml/CMakeLists.txt ===
add_executable(qml_test qml_test.cpp)
qt5_use_modules(qml_test Qml DBus QuickTest Test)
target_link_libraries(qml_test
    testutils
    Qt5::Qml
    Qt5::DBus
    Qt5::QuickTest
    Qt5::Test
)
add_dependencies(qml_test thumbnailer-service LomiriThumbnailer-qml)

if (${CMAKE_LIBRARY_ARCHITECTURE} STREQUAL "powerpc-linux-gnu"
    OR ${CMAKE_LIBRARY_ARCHITECTURE} STREQUAL "s390x-linux-gnu")
    message("Skipping qml test for ${CMAKE_LIBRARY_ARCHITECTURE}")
else()
    add_test(qml ${CMAKE_SOURCE_DIR}/tools/run-xvfb.sh ./qml_test -import ${CMAKE_BINARY_DIR}/plugins)
    # Clear some environment variables that can interfere with the tests
    set_tests_properties(qml PROPERTIES
      ENVIRONMENT "DBUS_SESSION_BUS_ADDRESS=;QT_QPA_PLATFORMTHEME="
    )
endif()

=== tests/recovery/CMakeLists.txt ===
add_executable(recovery_test recovery_test.cpp MockCache.cpp)
qt5_use_modules(recovery_test Network Core)
target_link_libraries(recovery_test Qt5::Core thumbnailer-static gtest gmock)
add_test(recovery recovery_test)

=== tests/safe_strerror/CMakeLists.txt ===
add_executable(safe_strerror_test safe_strerror_test.cpp)
qt5_use_modules(safe_strerror_test Network)
target_link_libraries(safe_strerror_test thumbnailer-static Qt5::Network gtest gtest_main)
add_test(safe_strerror safe_strerror_test)

=== tests/settings/CMakeLists.txt ===
add_executable(settings_test settings_test.cpp)
qt5_use_modules(settings_test Network Core) # for QTemporaryDir
target_link_libraries(settings_test thumbnailer-static Qt5::Network Qt5::Core gtest)
add_test(settings settings_test)

=== tests/stress/CMakeLists.txt ===
add_executable(stress_test stress_test.cpp)
set_target_properties(stress_test PROPERTIES AUTOMOC TRUE)
qt5_use_modules(stress_test Quick Network DBus Test)
target_link_libraries(stress_test
    lomiri-thumbnailer-qt
    testutils
    ${GST_DEPS_LDFLAGS}
    Qt5::Quick
    Qt5::Network
    Qt5::DBus
    Qt5::Test
    gtest
)
add_test(stress stress_test)
add_dependencies(stress_test thumbnailer-service)

=== tests/thumbnailer-admin/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/tests)
include_directories(${CMAKE_BINARY_DIR}/tests)

add_executable(thumbnailer-admin_test
    thumbnailer-admin_test.cpp
)
qt5_use_modules(thumbnailer-admin_test Network Test)
target_link_libraries(thumbnailer-admin_test
    gtest
    thumbnailer-static
    testutils
    Qt5::Network
    Qt5::Test
)
add_dependencies(thumbnailer-admin_test lomiri-thumbnailer-admin thumbnailer-service)
add_test(thumbnailer-admin thumbnailer-admin_test)

=== tests/utils/CMakeLists.txt ===
pkg_check_modules(QTDBUSTEST_DEPS REQUIRED libqtdbustest-1)
add_definitions(${QTDBUSTEST_DEPS_CFLAGS})

set_source_files_properties(
    "${CMAKE_SOURCE_DIR}/src/service/dbusinterface.xml" PROPERTIES
    CLASSNAME ThumbnailerInterface
    INCLUDE ${CMAKE_SOURCE_DIR}/include/service/client_config.h
)
qt5_add_dbus_interface(
    interface_files
    "${CMAKE_SOURCE_DIR}/src/service/dbusinterface.xml"
    thumbnailerinterface
)

set_source_files_properties(
    "${CMAKE_SOURCE_DIR}/src/service/admininterface.xml" PROPERTIES
    CLASSNAME AdminInterface
    INCLUDE ${CMAKE_SOURCE_DIR}/src/service/stats.h
)
qt5_add_dbus_interface(
    interface_files
    "${CMAKE_SOURCE_DIR}/src/service/admininterface.xml"
    admininterface
)

add_library(testutils STATIC
    artserver.cpp
    dbusserver.cpp
    supports_decoder.cpp
    testutils.cpp
    ${interface_files}
    ${CMAKE_SOURCE_DIR}/src/service/stats.cpp
)
qt5_use_modules(testutils Core DBus Test)
target_link_libraries(testutils
    Qt5::DBus Qt5::Core Qt5::Test ${QTDBUSTEST_DEPS_LIBRARIES} thumbnailer-static
)

=== tests/version/CMakeLists.txt ===
add_executable(version_test
    version_test.cpp
)
qt5_use_modules(version_test Test)
target_link_libraries(version_test
    Qt5::Test
    thumbnailer-static
    testutils
    gtest)
add_test(version version_test)

=== debian/changelog ===
lomiri-thumbnailer (3.0.0-2) unstable; urgency=medium

  * debian/patches:
    + Add 1003_ignore-more-media-formats-during-copyright-check.patch. Also
      ignore .mp4 and .spx files during copyright test. (Closes: #1002908).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 31 Jan 2022 16:19:40 +0100

lomiri-thumbnailer (3.0.0-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1000591).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 26 Nov 2021 11:18:30 +0100

=== debian/control ===
Source: lomiri-thumbnailer
Section: misc
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               cmake-extras (>= 0.4),
               debhelper-compat (= 13),
               google-mock,
               gstreamer1.0-libav,
               gstreamer1.0-plugins-bad-faad,
               gstreamer1.0-plugins-good,
               libapparmor-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-regex-dev,
               libexif-dev,
               libgdk-pixbuf2.0-dev,
               libgstreamer1.0-dev,
               libgstreamer-plugins-base1.0-dev,
               libgtest-dev,
               libleveldb-dev,
               libqtdbustest1-dev,
               librsvg2-common,
               libtag1-dev,
               liblomiri-api-dev,
               licensecheck,
               lsb-release,
               persistent-cache-cpp-dev (>= 1.0.5-2~),
               python3-tornado <!nocheck>,
               qml-module-qtquick2,
               qml-module-qttest,
               qtbase5-dev,
               qtbase5-dev-tools,
               qtdeclarative5-dev,
               shared-mime-info,
               xauth,
               xvfb,
               doxygen,
               pkg-kde-tools,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/core/lomiri-thumbnailer
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-thumbnailer/
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-thumbnailer.git

Package: lomiri-thumbnailer-service
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends},
Depends: dconf-cli,
         ${misc:Depends},
         ${shlibs:Depends},
Conflicts: libthumbnailer0, thumbnailer-common
Replaces: libthumbnailer0, thumbnailer-common
Description: D-Bus service for out of process thumbnailing
 Lomiri Thumbnailer is an API for the Lomiri operating environment to
 create and cache image thumbnails for local and remote media.
 .
 This package provides thumbnailer D-Bus service that can provide
 thumbnails on behalf of another process.

Package: qml-module-lomiri-thumbnailer
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-thumbnailer-qt1.0 (= ${binary:Version}),
Recommends: lomiri-thumbnailer-service (= ${binary:Version}),
Description: QML interface for the thumbnailer
 Lomiri Thumbnailer is an API for the Lomiri operating environment to
 create and cache image thumbnails for local and remote media.
 .
 This package provides image providers that allow access to the
 thumbnailer from Qt Quick 2 / QML applications.

Package: liblomiri-thumbnailer-qt1.0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
         lomiri-thumbnailer-service,
Description: Qt/C++ API to obtain thumbnails
 Lomiri Thumbnailer is an API for the Lomiri operating environment to
 create and cache image thumbnails for local and remote media.
 .
 Library providing a client API for obtaining thumbnails from the DBus
 service.

Package: liblomiri-thumbnailer-qt-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: liblomiri-thumbnailer-qt1.0 (= ${binary:Version}),
         ${misc:Depends},
Description: Qt/C++ API to obtain thumbnails (development files)
 Lomiri Thumbnailer is an API for the Lomiri operating environment to
 create and cache image thumbnails for local and remote media.
 .
 Library providing a client API for obtaining thumbnails from the DBus
 service.
 .
 This package provides the development files for the library.

#Package: liblomiri-thumbnailer-qt-doc
#Section: doc
#Architecture: all
#Multi-Arch: foreign
#Depends: ${misc:Depends},
#Description: Documentation for Thumbnailer API
# Lomiri Thumbnailer is an API for the Lomiri operating environment to
# create and cache image thumbnails for local and remote media.
# .
# API documentation of Thumbnailer API.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

NULL =

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

export DPKG_GENSYMBOLS_CHECK_LEVEL=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# http://ccache.samba.org/manual.html#_precompiled_headers
export CCACHE_SLOPPINESS=time_macros

export QT_SELECT=qt5

%:
	dh $@ --with pkgkde_symbolshelper

distro=$(shell lsb_release -c -s)
ifeq ($(distro), focal)
	# GlibC 2.31 in Ubuntu Focal has a bug which tries to use static-TLS area
	# to optimize TLS access in dynamically-loaded libraries, but end up not
	# having enough static-TLS area for the library that need it. See CMakeLists.txt
	# in the root. The issue is fixed in Glibc 2.32, but GlibC 2.31 in Debian seems
	# to be patched, thus this is not needed for Debian.
	ifneq ($(filter arm64 ppc64el, $(DEB_HOST_ARCH)),)
		ARCH_OPT := -DWORKAROUND_LIBGOMP_STATIC_TLS=ON
	endif
endif

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_SYSCONFDIR=/etc \
	                     -DENABLE_UBUNTU_COMPAT=ON $(ARCH_OPT) \
	                     $(NULL)

# Tests are not written to be run in parallel.
# We ignore failing tests on PPC because the thumbnailer is irrelevant there,
# and gstreamer has bugs in the plugins for PPC.
test_args = --max-parallel=1 -- ARGS=\"--verbose\"
override_dh_auto_test:
#ifneq (,$(filter powerpc ppc64el s390x,$(DEB_HOST_ARCH)))
#	dh_auto_test $(test_args) || :
#else
	dh_auto_test $(test_args)
#endif

override_dh_install:
	rm debian/tmp/usr/lib/*/qt5/qml/Ubuntu/Thumbnailer.0.1/LomiriThumbnailerLoader.qml
	rm -Rv debian/tmp/usr/lib/*/qt5/qml/Ubuntu/Thumbnailer.0.1/qmldir
	dh_install

override_dh_missing:
	dh_missing --fail-missing

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
https://gitlab.com/ubports/core/lomiri-thumbnailer/tags .*/lomiri-thumbnailer-(\d\S+)\.tar\.gz

## lomiri-thumbnailer 3.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 endif()
 
 cmake_minimum_required(VERSION 3.0.2)
-project(lomiri-thumbnailer VERSION "3.0.0" LANGUAGES C CXX)
+project(lomiri-thumbnailer VERSION "3.0.1" LANGUAGES C CXX)
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
@@ -139,8 +139,8 @@
 
 include(cmake/UseGSettings.cmake)
 
-set(SHARE_PRIV_DIR ${CMAKE_INSTALL_LIBDIR}/lomiri-thumbnailer)
-set(SHARE_PRIV_ABS ${CMAKE_INSTALL_FULL_LIBDIR}/lomiri-thumbnailer)
+set(SHARE_PRIV_DIR ${CMAKE_INSTALL_LIBEXECDIR}/lomiri-thumbnailer)
+set(SHARE_PRIV_ABS ${CMAKE_INSTALL_FULL_LIBEXECDIR}/lomiri-thumbnailer)
 
 find_package(Boost COMPONENTS filesystem iostreams regex system REQUIRED)
 find_package(Threads REQUIRED)

=== doc/liblomiri-thumbnailer-qt/CMakeLists.txt ===
include(UseDoxygen OPTIONAL)

file(GLOB libthumbnailer_headers "${PROJECT_SOURCE_DIR}/include/lomiri/thumbnailer/qt/*.h")

add_doxygen(
    liblomiri-thumbnailer-qt-doc
    INPUT
        ${CMAKE_CURRENT_SOURCE_DIR}/tutorial.dox
        ${libthumbnailer_headers}
    OUTPUT_DIRECTORY
        ${CMAKE_BINARY_DIR}/doc/liblomiri-thumbnailer-qt
    STRIP_FROM_PATH
        "${CMAKE_SOURCE_DIR}/src"
    STRIP_FROM_INC_PATH
        "${CMAKE_SOURCE_DIR}/include"
    EXCLUDE_PATTERNS
        */internal/*
    EXCLUDE_SYMBOLS
        *::internal*
        *::Priv
    EXAMPLE_PATH
        ${CMAKE_CURRENT_SOURCE_DIR}
    DOXYFILE_IN
        ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
    PROJECT_NAME
        "Thumbnailer Qt API"
    ALL
)

install(DIRECTORY ${PROJECT_BINARY_DIR}/doc/liblomiri-thumbnailer-qt/html
        DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/doc/liblomiri-thumbnailer-qt)

add_subdirectory(examples)

list(APPEND UNIT_TEST_TARGETS qt_example_test)
set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} PARENT_SCOPE)

=== src/thumbnailer-admin/CMakeLists.txt ===
set(dbusinterface_xml "${CMAKE_SOURCE_DIR}/src/service/dbusinterface.xml")
set_source_files_properties(${dbusinterface_xml} PROPERTIES
    CLASSNAME ThumbnailerInterface
    INCLUDE ${CMAKE_SOURCE_DIR}/include/service/client_config.h)
qt5_add_dbus_interface(interface_files ${dbusinterface_xml} thumbnailerinterface)

set(admininterface_xml "${CMAKE_SOURCE_DIR}/src/service/admininterface.xml")
set_source_files_properties(${admininterface_xml} PROPERTIES
    CLASSNAME AdminInterface
    INCLUDE ${CMAKE_SOURCE_DIR}/src/service/stats.h)
qt5_add_dbus_interface(interface_files ${admininterface_xml} admininterface)

add_executable(lomiri-thumbnailer-admin
    clear.cpp
    dbus_connection.cpp
    get_local_thumbnail.cpp
    get_remote_thumbnail.cpp
    parse_size.cpp
    show_stats.cpp
    shutdown.cpp
    thumbnailer-admin.cpp
    util.cpp
    ${CMAKE_SOURCE_DIR}/src/file_io.cpp
    ${CMAKE_SOURCE_DIR}/src/safe_strerror.cpp
    ${CMAKE_SOURCE_DIR}/src/service/stats.cpp
    ${interface_files}
)
target_link_libraries(lomiri-thumbnailer-admin thumbnailer-static Qt5::DBus ${CACHE_DEPS_LDFLAGS} ${Boost_LIBRARIES})
add_dependencies(lomiri-thumbnailer-admin thumbnailer-service)

INSTALL(TARGETS lomiri-thumbnailer-admin
        RUNTIME
        DESTINATION bin)

=== tests/file_lock/CMakeLists.txt ===
add_executable(file_lock_test file_lock_test.cpp)
qt5_use_modules(file_lock_test Network)
target_link_libraries(file_lock_test Qt5::Network thumbnailer-static gtest)
add_test(file_lock file_lock_test)

add_executable(hold_lock hold_lock.cpp)
target_link_libraries(hold_lock thumbnailer-static)
list(APPEND UNIT_TEST_TARGETS hold_lock)
set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} PARENT_SCOPE)

=== tests/image-provider/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/plugins/Lomiri/Thumbnailer.0.1)

add_executable(image-provider_test image-provider_test.cpp)
qt5_use_modules(image-provider_test Quick Test)
target_link_libraries(image-provider_test
  thumbnailer-qml-static
  testutils
  Qt5::Quick
  Qt5::Test
  gtest)
add_test(image-provider ${CMAKE_SOURCE_DIR}/tools/run-xvfb.sh ./image-provider_test)

=== tests/liblomiri-thumbnailer-qt/CMakeLists.txt ===
add_executable(liblomiri-thumbnailer-qt_test liblomiri-thumbnailer-qt_test.cpp)
set_target_properties(liblomiri-thumbnailer-qt_test PROPERTIES AUTOMOC TRUE)

qt5_use_modules(liblomiri-thumbnailer-qt_test DBus Gui Test Network)
target_link_libraries(liblomiri-thumbnailer-qt_test
    lomiri-thumbnailer-qt
    Qt5::DBus
    Qt5::Gui
    Qt5::Test
    gtest
    testutils
    ${GST_DEPS_LDFLAGS}
)
add_test(liblomiri-thumbnailer-qt liblomiri-thumbnailer-qt_test)
add_dependencies(liblomiri-thumbnailer-qt_test lomiri-thumbnailer-qt)
list(APPEND UNIT_TEST_TARGETS "liblomiri-thumbnailer-qt_test")

set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} PARENT_SCOPE)

=== debian/changelog ===
lomiri-thumbnailer (3.0.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop patch 0001, 0002, 0003, 1001, 1002, 1003 and 1200. All
      applied/addressed upstream.
    + Add 2001_ignore-more-file-types-in-copyright-check.patch. Fix
      check_copyright.sh when building for Debian
  * debian/control:
    + Bump Standards-Version: to 4.6.2. No changes needed.
  * debian/rules:
    + (Re-)add get-orig-source target.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 05 Feb 2023 17:03:53 +0100

lomiri-thumbnailer (3.0.0-5) unstable; urgency=medium

  * Team upload.

  * [26e53e6] Disable qml test on mips64el.

 -- Anton Gladky <gladk@debian.org>  Wed, 05 Oct 2022 06:17:23 +0200

lomiri-thumbnailer (3.0.0-4) unstable; urgency=medium

  * Team upload.

  * [6458a51] Disable qml and dbus tests on some archs

 -- Anton Gladky <gladk@debian.org>  Tue, 04 Oct 2022 06:37:50 +0200

lomiri-thumbnailer (3.0.0-3) unstable; urgency=medium

  * Team upload.

  [ Mike Gabriel ]
  * [6844c1a] debian/: Update upstream Git repo URL.

  [ Anton Gladky ]
  * [3ddd3ad] Add debian/.gitlab-ci.yml
  * [451c874] Add missing header. (Closes: #1012993)
  * [c7fcd40] Set Standards-Versions to 4.6.1
  * [b8a5ab7] Set upstream metadata fields: Repository.
  * [fb984f7] Remove unnecessary get-orig-source-target.

 -- Anton Gladky <gladk@debian.org>  Sun, 02 Oct 2022 23:50:06 +0200

=== debian/control ===
--- 
+++ 
@@ -39,9 +39,9 @@
                xvfb,
                doxygen,
                pkg-kde-tools,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
-Homepage: https://gitlab.com/ubports/core/lomiri-thumbnailer
+Homepage: https://gitlab.com/ubports/development/core/lomiri-thumbnailer
 Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-thumbnailer/
 Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-thumbnailer.git

=== debian/watch ===
version=4
https://gitlab.com/ubports/development/core/lomiri-thumbnailer/tags .*/lomiri-thumbnailer-(\d\S+)\.tar\.gz

## lomiri-thumbnailer 3.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 endif()
 
 cmake_minimum_required(VERSION 3.0.2)
-project(lomiri-thumbnailer VERSION "3.0.1" LANGUAGES C CXX)
+project(lomiri-thumbnailer VERSION "3.0.2" LANGUAGES C CXX)
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)

=== debian/changelog ===
lomiri-thumbnailer (3.0.2-3) unstable; urgency=medium

  * Team upload.
  * d/patches:
    + Fix test failures against boost1.83.
      3000_fix_boost183.patch (Closes: #1059174)
    + 1001_rename_apport_directory.patch
      Rename /etc/apport/blacklist.d to /etc/apport/report-ignore.
      (Closes: #1031508)

 -- Anton Gladky <gladk@debian.org>  Thu, 04 Jan 2024 20:44:11 +0100

lomiri-thumbnailer (3.0.2-3~exp1) experimental; urgency=medium

  * Team upload.
  * Fix check for missing file.

 -- Anton Gladky <gladk@debian.org>  Thu, 04 Jan 2024 19:47:20 +0100

lomiri-thumbnailer (3.0.2-2) unstable; urgency=medium

  * debian/patches:
    + Update 2001_ignore-more-file-types-in-copyright-check.patch.
      Exclude upstream ChangeLog from checks in check_copyright.sh unit test.
  * debian/changelog:
    + White-space cleanup.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 29 Oct 2023 09:43:18 +0100

lomiri-thumbnailer (3.0.2-1) unstable; urgency=medium

  * New upstream release
  * d/control: replace B-D libgdk-pixbuf2.0-dev with
    libgdk-pixbuf-2.0-dev (closes: #1037393)

 -- Marius Gripsgard <mariogrip@debian.org>  Sun, 29 Oct 2023 00:21:52 +0200

lomiri-thumbnailer (3.0.1-2) unstable; urgency=medium

  [ Mike Gabriel ]
  * d/changelog: post-upload add missing item

  [ Marius Gripsgard ]
  * debian/patches: Add patch to fix FTBFS with googletest 1.13.0
    (closes: #1037764)
  * debian/control: Add myself as uploader

 -- Marius Gripsgard <mariogrip@debian.org>  Thu, 27 Jul 2023 15:45:33 +0200

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
+ Marius Gripsgard <mariogrip@debian.org>,
 Build-Depends: cmake,
                cmake-extras (>= 0.4),
                debhelper-compat (= 13),
@@ -12,11 +13,12 @@
                gstreamer1.0-plugins-bad-faad,
                gstreamer1.0-plugins-good,
                libapparmor-dev,
+               libboost-dev,
                libboost-filesystem-dev,
                libboost-iostreams-dev,
                libboost-regex-dev,
                libexif-dev,
-               libgdk-pixbuf2.0-dev,
+               libgdk-pixbuf-2.0-dev,
                libgstreamer1.0-dev,
                libgstreamer-plugins-base1.0-dev,
                libgtest-dev,

## lomiri-thumbnailer 3.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,8 @@
     set(LOCAL_INSTALL "ON")
 endif()
 
-cmake_minimum_required(VERSION 3.0.2)
-project(lomiri-thumbnailer VERSION "3.0.2" LANGUAGES C CXX)
+cmake_minimum_required(VERSION 3.5)
+project(lomiri-thumbnailer VERSION "3.0.3" LANGUAGES C CXX)
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)

=== doc/CMakeLists.txt ===
add_subdirectory(liblomiri-thumbnailer-qt)

list(APPEND UNIT_TEST_TARGETS qt_example_test)
set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} PARENT_SCOPE)

=== man/CMakeLists.txt ===
set(section1
    lomiri-thumbnailer-admin.1
    thumbnailer-service.1
)

set(section5
    thumbnailer-settings.5
)

install(
    FILES ${CMAKE_CURRENT_SOURCE_DIR}/${section1}
    DESTINATION ${CMAKE_INSTALL_DATADIR}/man/man1
)

install(
    FILES ${CMAKE_CURRENT_SOURCE_DIR}/${section5}
    DESTINATION ${CMAKE_INSTALL_DATADIR}/man/man5
)

=== tests/CMakeLists.txt ===
# We add -g so we get debug info for the gtest stack frames with gdb.
# The warnings are suppressed so we get a noise-free build for gtest and gmock.

set(old_cxx_flags ${CMAKE_CXX_FLAGS})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wno-old-style-cast -Wno-missing-field-initializers")
find_package(GMock)
set(CMAKE_CXX_FLAGS ${old_cxx_flags})

find_package(Qt5Test REQUIRED)
find_package(Qt5QuickTest REQUIRED)
find_package(Qt5Network REQUIRED)

set(TESTDATADIR ${CMAKE_CURRENT_SOURCE_DIR}/media)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

configure_file(testsetup.h.in testsetup.h @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(utils)

set(unit_test_dirs
    art_extractor
    check_access
    dbus
    download
    file_io
    gobj_ptr
    image
    image-provider
    qml
    liblomiri-thumbnailer-qt
    recovery
    safe_strerror
    settings
    thumbnailer
    thumbnailer-admin
    version
    vs-thumb
)

set(slow_test_dirs
    backoff_adjuster
    file_lock
    slow-vs-thumb
    stress
)

set(UNIT_TEST_TARGETS "")

foreach(dir ${unit_test_dirs})
    add_subdirectory(${dir})
    list(APPEND UNIT_TEST_TARGETS "${dir}_test")
endforeach()

if (${slowtests})
    foreach(dir ${slow_test_dirs})
        add_subdirectory(${dir})
        list(APPEND UNIT_TEST_TARGETS "${dir}_test")
    endforeach()
    add_subdirectory(headers)
endif()

set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} PARENT_SCOPE)

if (${slowtests})
    add_subdirectory(copyright)
endif()
add_subdirectory(whitespace)

=== src/liblomiri-thumbnailer-qt/CMakeLists.txt ===
set(dbusinterface_xml "${CMAKE_SOURCE_DIR}/src/service/dbusinterface.xml")
set_source_files_properties(${dbusinterface_xml} PROPERTIES
  CLASSNAME ThumbnailerInterface
  INCLUDE ${CMAKE_SOURCE_DIR}/include/service/client_config.h)
qt5_add_dbus_interface(interface_files ${dbusinterface_xml} thumbnailerinterface)

add_library(${LIBTHUMBNAILER_QT} SHARED
  liblomiri-thumbnailer-qt.cpp
  ${CMAKE_SOURCE_DIR}/src/service/client_config.cpp
  ${CMAKE_SOURCE_DIR}/include/lomiri/thumbnailer/qt/lomiri-thumbnailer-qt.h
  ${interface_files}
)

include_directories(${CMAKE_BINARY_DIR}/src)

set_target_properties(${LIBTHUMBNAILER_QT} PROPERTIES
    VERSION "${LIBTHUMBNAILER_QT_SO_VERSION_MAJOR}.${LIBTHUMBNAILER_QT_SO_VERSION_MINOR}.${LIBTHUMBNAILER_QT_SO_VERSION_MICRO}"
    SOVERSION ${LIBTHUMBNAILER_QT_SO_VERSION}
)

set(symbol_map "${CMAKE_SOURCE_DIR}/src/liblomiri-thumbnailer-qt/liblomiri-thumbnailer-qt.map")
set_target_properties(${LIBTHUMBNAILER_QT} PROPERTIES
                      LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map} ")
set_target_properties(${LIBTHUMBNAILER_QT} PROPERTIES LINK_DEPENDS ${symbol_map})

target_link_libraries(${LIBTHUMBNAILER_QT} thumbnailer-static Qt5::DBus Qt5::Gui)
set_target_properties(${LIBTHUMBNAILER_QT} PROPERTIES AUTOMOC TRUE)
add_dependencies(${LIBTHUMBNAILER_QT} thumbnailer-service)

install(
  TARGETS lomiri-thumbnailer-qt
  LIBRARY DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}
)

# Set up package config.
configure_file(lib${LIBTHUMBNAILER_QT}.pc.in lib${LIBTHUMBNAILER_QT}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lib${LIBTHUMBNAILER_QT}.pc DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== tests/art_extractor/CMakeLists.txt ===
add_executable(art_extractor_test
    art_extractor_test.cpp
)
target_link_libraries(art_extractor_test
    Qt5::Test
    thumbnailer-static
    testutils
    gtest)
add_test(art_extractor art_extractor_test)

=== tests/dbus/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,4 @@
 add_executable(dbus_test dbus_test.cpp)
-qt5_use_modules(dbus_test Network DBus Test)
 target_link_libraries(dbus_test
     thumbnailer-static
     testutils

=== tests/file_lock/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,4 @@
 add_executable(file_lock_test file_lock_test.cpp)
-qt5_use_modules(file_lock_test Network)
 target_link_libraries(file_lock_test Qt5::Network thumbnailer-static gtest)
 add_test(file_lock file_lock_test)

=== tests/slow-vs-thumb/CMakeLists.txt ===
add_executable(slow-vs-thumb_test
    slow-vs-thumb_test.cpp
)
target_link_libraries(slow-vs-thumb_test
    thumbnailer-static
    testutils
    Qt5::Network
    Qt5::Test
    gtest)
add_test(slow-vs-thumb slow-vs-thumb_test)

=== debian/changelog ===
lomiri-thumbnailer (3.0.3-1build4) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 12 Apr 2024 05:39:41 +0000

lomiri-thumbnailer (3.0.3-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:59:01 +0000

lomiri-thumbnailer (3.0.3-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:46:22 +0000

lomiri-thumbnailer (3.0.3-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:35:19 +0000

lomiri-thumbnailer (3.0.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 3000_fix_boost183.patch. Applied upstream.
    + Trivial rebase of 1300_disable_qml_and_dbus_tests.patch.
  * debian/copyright:
    + Update copyright attribution for debian/.
  * debian/control:
    + Bump versioned D: on persistent-cache-cpp-dev to 1.0.7-1~ (latest
      version).

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 01 Feb 2024 17:45:55 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: lomiri-thumbnailer
 Section: misc
 Priority: optional
-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
  Marius Gripsgard <mariogrip@debian.org>,
@@ -29,7 +30,7 @@
                liblomiri-api-dev,
                licensecheck,
                lsb-release,
-               persistent-cache-cpp-dev (>= 1.0.5-2~),
+               persistent-cache-cpp-dev (>= 1.0.7-1~),
                python3-tornado <!nocheck>,
                qml-module-qtquick2,
                qml-module-qttest,

## lomiri-thumbnailer 3.0.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 endif()
 
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-thumbnailer VERSION "3.0.3" LANGUAGES C CXX)
+project(lomiri-thumbnailer VERSION "3.0.4" LANGUAGES C CXX)
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
@@ -23,7 +23,7 @@
 
 set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
 
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++11 -Wall -pedantic -Wextra -fvisibility=hidden")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++17 -Wall -pedantic -Wextra -fvisibility=hidden")
 
 # Some additional warnings not included by the general flags set above.
 set(EXTRA_C_WARNINGS "-Wcast-align -Wcast-qual -Wformat -Wredundant-decls -Wswitch-default")
@@ -133,7 +133,6 @@
 endif()
 
 include(CTest)
-enable_testing()
 
 #include(EnableCoverageReport)
 
@@ -176,7 +175,13 @@
 if (${ENABLE_UBUNTU_COMPAT})
     add_subdirectory(plugins/Ubuntu/Thumbnailer.0.1)
 endif()
-add_subdirectory(tests)
+if (${BUILD_TESTING})
+    find_package(Qt5Test REQUIRED)
+    find_package(Qt5QuickTest REQUIRED)
+    find_package(Qt5Network REQUIRED)
+
+    add_subdirectory(tests)
+endif()
 add_subdirectory(include)
 add_subdirectory(man)
 #add_subdirectory(doc)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -5,10 +5,6 @@
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wno-old-style-cast -Wno-missing-field-initializers")
 find_package(GMock)
 set(CMAKE_CXX_FLAGS ${old_cxx_flags})
-
-find_package(Qt5Test REQUIRED)
-find_package(Qt5QuickTest REQUIRED)
-find_package(Qt5Network REQUIRED)
 
 set(TESTDATADIR ${CMAKE_CURRENT_SOURCE_DIR}/media)

=== include/internal/CMakeLists.txt ===
configure_file(config.h.in config.h @ONLY)
configure_file(version.h.in version.h @ONLY)

=== tests/check_access/CMakeLists.txt ===
add_executable(check_access_test check_access_test.cpp)
target_link_libraries(check_access_test thumbnailer-static Qt5::Network gtest)
add_test(check_access check_access_test)

=== tests/qml/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,4 @@
 add_executable(qml_test qml_test.cpp)
-qt5_use_modules(qml_test Qml DBus QuickTest Test)
 target_link_libraries(qml_test
     testutils
     Qt5::Qml

=== tests/version/CMakeLists.txt ===
add_executable(version_test
    version_test.cpp
)
target_link_libraries(version_test
    Qt5::Test
    thumbnailer-static
    testutils
    gtest)
add_test(version version_test)

=== doc/liblomiri-thumbnailer-qt/examples/CMakeLists.txt ===
include_directories(${CMAKE_BINARY_DIR}/tests ${CMAKE_SOURCE_DIR}/tests)
add_executable(qt_example_test qt_example_test.cpp)
qt5_use_modules(qt_example_test Core Gui Network Test)
target_link_libraries(qt_example_test
    gtest
    Qt5::Core
    Qt5::Gui
    Qt5::Network
    Qt5::Test
    testutils
    lomiri-thumbnailer-qt
)
set_target_properties(qt_example_test PROPERTIES AUTOMOC TRUE)
add_dependencies(qt_example_test thumbnailer-service)

add_test(qt_example qt_example_test)

list(APPEND UNIT_TEST_TARGETS qt_example_test)
set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} PARENT_SCOPE)

=== include/lomiri/thumbnailer/CMakeLists.txt ===
add_subdirectory(qt)

=== debian/changelog ===
lomiri-thumbnailer (3.0.4-2) unstable; urgency=medium

  [ Boyuan Yang ]
  * debian/patches:
    + Add 0004-Fix-taglib-2.x-compatibility.patch. Fix taglib 2.x compat.
      (Closes: #1092683).
  * debian/control:
    + Switch to libtag-dev in B-D: field.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 13 Jan 2025 08:20:53 +0100

lomiri-thumbnailer (3.0.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.
  * debian/control:
    + Bump Standards-Version: to 4.7.0. No changes needed.
  * debian/patches:
    + Drop 0001_fix_googletest_1_13.patch and 2001_ignore-more-file-types-
      in-copyright-check.patch. Both applied upstream.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 07 Jan 2025 10:35:20 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: lomiri-thumbnailer
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
  Marius Gripsgard <mariogrip@debian.org>,
@@ -26,7 +25,7 @@
                libleveldb-dev,
                libqtdbustest1-dev,
                librsvg2-common,
-               libtag1-dev,
+               libtag-dev,
                liblomiri-api-dev,
                licensecheck,
                lsb-release,
@@ -42,7 +41,7 @@
                xvfb,
                doxygen,
                pkg-kde-tools,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/lomiri-thumbnailer
 Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-thumbnailer/
